/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * ============================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://openbluesky.kenai.com
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id$
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.windows.role;

import javax.inject.Inject;
import it.tidalwave.netbeans.role.DataLoader;

/***********************************************************************************************************************
 *
 * This methodless role represents the capability of loading data into a {@link org.openide.windows.TopComponent}.
 * Subclasses might implement different strategies (e.g. lazy or eager). The actual task of loading data is delegated to a
 * {@link DataLoader} that must be present in the {@code Lookup}.
 *
 * @stereotype Role
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public abstract class TopComponentDataLoaderStrategy extends TopComponentRoleSupport
        // implements DataLoader --  causes ambiguity with the delegate, e.g. can be auto-injected
  {
    @Inject
    private DataLoader dataLoader;

//    @Override
    protected final void loadData()
      {
        dataLoader.loadData();
      }
  }
